//<head>//////////////////////////////////////////////////////////////
//
//	
//	Lexed version 3.1
//	Copyright (C) 1999 2000 2001 2002 2003.
//	Universit Paris 7
//	INRIA Rocquencourt
//
//	Conception & programmation :
//	Lionel Clment
//	e-mail : lionel.clement@linguist.jussieu.fr
//
//	vendredi 18 janvier 2002, 13h41
//
//
////////////////////////////////////////////////////////////////</head>////

#include <stdio.h>
#include <string.h>

#include "lexedtree.h"
#include "lexedtcp.h"

//#define DIFF

char *Sep_Pref;
char *Sep_Or;
char *Sep_Suff;
char *Sep_Uw;
int LexedMemory;
int LexedIndexation;
char *LexedBuffer;
char Port[255];
unsigned long int nbreItem;
unsigned long int nbreItemMax;
char Mot[LEXEDMAXSTRING];
int swap;

Fsa *fsa;         // table fsa
InfoBuff *info;   //table des info
TYPEPTR LexedInitial;
Arbre *LexiqueInit;
Arbre *Lexique;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
void PrintResults (TYPEPTR Index,
		   int ClientServer, 
		   TcpServer *server, 
		   int Sep,
		   FILE *Table)
{
  char Etiquette[LEXEDMAXSTRING]; 
  if (ClientServer){ if (Sep) server->PutData(Sep_Pref); } else { if (Sep) fputs(Sep_Pref, stdout); }
  if (Index == (TYPEPTR)(~(0UL))){
    if (ClientServer){
      server->PutData(Sep_Uw);
      if (Sep) server->PutData(Sep_Suff);
    }
    else{
      fputs(Sep_Uw, stdout);
      if (Sep) fputs(Sep_Suff, stdout);
    }
    return;
  }
  while (Index != (TYPEPTR)(~(0UL))){
    // an other element will be describe
    if (LexedIndexation){
      sprintf(Etiquette, "%lX", info[Index].offset);
    } else {
      if (LexedMemory)
	strcpy (Etiquette, LexedBuffer+(info[Index].offset));
      else{
	fseek (Table, info[Index].offset, SEEK_SET);
	fgets (Etiquette, LEXEDMAXSTRING, Table);
      }
    }
    if (ClientServer){
      server->PutData(Etiquette);
      if (info[Index].suivant!=(TYPEPTR)(~(0UL)))
	server->PutData(Sep_Or);
    }
    else{
      fputs(Etiquette, stdout);
      if (info[Index].suivant!=(TYPEPTR)(~(0UL)))
	fputs(Sep_Or, stdout);
    }
    if ((info[Index].suivant)!=(TYPEPTR)(~(0UL)))
      Index=info[Index].suivant;
    else
      Index=(TYPEPTR)(~(0UL));
  }
  if (ClientServer){ if (Sep) server->PutData(Sep_Suff); } else { if (Sep) fputs(Sep_Suff, stdout); }
  return;
}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
void sPrintResults (TYPEPTR Index,
		    char ***Result,
		    int *ResultSize,
		    int *ResultIndex,
		    FILE *Table)
{
  char Etiquette[LEXEDMAXSTRING]; 

  if ((*Result)==NULL){
    *ResultSize=LEXEDMAXRESULT;
    if ((*Result = (char **)calloc(LEXEDMAXRESULT, sizeof(char*)))==NULL){
      fputs("*** too much allocation\n", stderr);
      exit(1);
    }
    *ResultIndex=0;
  }

  if (Index == (TYPEPTR)(~(0UL))){
    strcpy((*Result)[*ResultIndex], Sep_Uw);
    (*Result)[(*ResultIndex)+1]=NULL;
    (*ResultIndex)++;
    return;
  }
  while (Index != (TYPEPTR)(~(0UL))){
    if ((*ResultIndex) >= (*ResultSize)) {
      (*ResultSize) *= 2;
      if ((*Result = (char **)realloc(*Result, sizeof(char*) * (*ResultSize)))==NULL){
	fputs("*** too much allocation\n", stderr);
	exit(1);
      }
    }
    // an other element will be describe
    if (LexedIndexation){
      sprintf(Etiquette, "%lX", info[Index].offset);
    } else {
      if (LexedMemory)
	strcpy (Etiquette, LexedBuffer+(info[Index].offset));
      else{
	fseek (Table, info[Index].offset, SEEK_SET);
	fgets (Etiquette, LEXEDMAXSTRING, Table);
      }
    }
    (*Result)[*ResultIndex]=strdup(Etiquette);
    (*Result)[(*ResultIndex)+1]=NULL;
    (*ResultIndex)++;
        
    if ((info[Index].suivant)!=(TYPEPTR)(~(0UL)))
      Index=info[Index].suivant;
    else
      Index=(TYPEPTR)(~(0UL));
  }
  return;
}

////////////////////////////////////////////////////////////
// input: string
// output: info
////////////////////////////////////////////////////////////
TYPEPTR SearchStatic(TYPEPTR Index,
		     char *Str)
{
  char *car=Str;
  Index=fsa[Index].fils;
  // for each letter of the suffix
  while (*car){
    // parse the brothers while founding the actual char
    while (*car != fsa[Index].car){
      if (fsa[Index].frere != (TYPEPTR)(~(0UL)))
	Index=fsa[Index].frere;
      else
	return (TYPEPTR)(~(0UL));
    }
    if (*car != fsa[Index].car)
      return ((TYPEPTR)(~(0UL)));
    if (*(car+1)){
      if (fsa[Index].fils != (TYPEPTR)(~(0UL)))
	Index=fsa[Index].fils;
      else
	return (TYPEPTR)(~(0UL));
    } else
      if (fsa[Index].info != (TYPEPTR)(~(0UL)))
	return fsa[Index].info;
    car++;
  } 
  return (TYPEPTR)(~(0UL));
}

TYPEPTR WeightReplace=1;
TYPEPTR WeightAddDouble=3;
TYPEPTR WeightEraseDouble=3;
TYPEPTR WeightSwap=4;
TYPEPTR WeightSubstitute=5;
TYPEPTR WeightAdd=6;
TYPEPTR WeightErase=6;

////////////////////////////////////////////////////////////
// input: string
// output: list of info
////////////////////////////////////////////////////////////
void Search(TYPEPTR Index,
	    int ClientServer, 
	    TcpServer *server, 
	    char *Suffix,
	    int NbreApproxErase, 
	    int NbreApproxSubstitute, 
	    int NbreApproxAdd, 
	    int NbreApproxSwap, 
	    int NbreApproxEraseDouble, 
	    int NbreApproxAddDouble,
	    int NbreApproxReplace, 
	    struct FindReplaceStructure *Replace,
	    int AlreadyModified,
	    TYPEPTR **Result, 
	    int *ResultSize,
	    int *ResultIndex,
	    TYPEPTR Weight)
{
  //TYPEPTR Sy;
  char *car=Suffix;
  //fputs (Suffix, stderr);
  //fputc ('\n', stderr);
  //for (int i=0;i<AlreadyModified;i++)
  //  fputc (' ', stderr);
  //fputc ('^', stderr);
  //fputc ('\n', stderr);
  
  for (TYPEPTR Sy=fsa[Index].fils;
       Sy!=(TYPEPTR)(~(0UL));
       Sy=fsa[Sy].frere){
    if (*car){
      if (!*(car+1)){
	int cont=0;
	if (fsa[Sy].car==*car)
	  cont=1;
	if (NbreApproxSubstitute && !AlreadyModified){
	  cont=1;
	}
	if (NbreApproxReplace && !AlreadyModified){
	  for (struct FindReplaceStructure *Rep=Replace;Rep!=NULL && (*Rep).Find!=NULL;Rep++){
	    if((strchr((*Rep).Find, *car)!=NULL) && (strchr((*Rep).Repl, fsa[Sy].car)!=NULL)){
	      cont=1;
	      break;
	    }
	  }
	}
	if (cont){
	  if (fsa[Sy].info != (TYPEPTR)(~(0UL))){
	    if ((*Result)==NULL){
	      *ResultSize=LEXEDMAXRESULT;
	      if ((*Result = (TYPEPTR *)calloc(LEXEDMAXRESULT, sizeof(TYPEPTR)))==NULL){
		fputs("*** too much allocation\n", stderr);
		exit(1);
	      }
	      
	      *ResultIndex=0;
	    }
	    if ((*ResultIndex) == (*ResultSize)) {
	      (*ResultSize) *= 2;
	      if ((*Result = (TYPEPTR *)realloc(*Result, sizeof(TYPEPTR) * (*ResultSize)))==NULL){
		fputs("*** too much allocation\n", stderr);
		exit(1);
	      }
	    }
	    (*Result)[*ResultIndex]=fsa[Sy].info;
	    (*Result)[(*ResultIndex)+1]=Weight;
	    if ((NbreApproxSubstitute) && (fsa[Sy].car!=*car))
	      (*Result)[(*ResultIndex)+1]+=WeightSubstitute;
	    if ((NbreApproxReplace) && (fsa[Sy].car!=*car))
	      (*Result)[(*ResultIndex)+1]+=WeightReplace;
	    (*Result)[(*ResultIndex)+2]=(TYPEPTR)~0UL;
	    (*ResultIndex)++;
	    (*ResultIndex)++;
	  }
	}
      }
      if (fsa[Sy].car==*car)
	Search(Sy, ClientServer, server, car+1, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified?AlreadyModified-1:0, Result, ResultSize, ResultIndex, Weight);
      else {
	if (NbreApproxSubstitute && !AlreadyModified){
	  Search(Sy, ClientServer, server, car+1, NbreApproxErase, NbreApproxSubstitute-1, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified?AlreadyModified-1:0, Result, ResultSize, ResultIndex, Weight + WeightSubstitute);
	}
	if (NbreApproxReplace && !AlreadyModified){
	  int cont=0;
	  if(Replace!=NULL){
	    for (struct FindReplaceStructure *Rep=Replace;Rep!=NULL && (*Rep).Find!=NULL;Rep++){
	      //fprintf(stderr, "*** <%s,%s>\n", (*Rep).Find, (*Rep).Repl);
	      if((strchr((*Rep).Find, *car)!=NULL) && (strchr((*Rep).Repl, fsa[Sy].car)!=NULL)){
		cont=1;
		break;
	      }
	    }
	  } else 
	    cont=1;
	  if (cont)
	    Search(Sy, ClientServer, server, car+1, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace-1, Replace, AlreadyModified?AlreadyModified-1:0, Result, ResultSize, ResultIndex, Weight + WeightReplace);
	}
      }
    }
    if (NbreApproxAdd && !AlreadyModified && fsa[Sy].car!=*(car)){
      char *aux=(char*)calloc(strlen(car)+2, sizeof(char));
      strcpy(aux, car);
      for (int i=strlen(aux);i;i--)
	*(aux+i) = *(aux+i-1);
      *aux=fsa[Sy].car;
      Search(Index, ClientServer, server, aux, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd-1, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified+1, Result, ResultSize, ResultIndex, Weight + WeightAdd);
      free(aux);
    }
    if (NbreApproxAddDouble && !AlreadyModified && fsa[Sy].car==*(car)){
      char *aux=(char*)calloc(strlen(car)+2, sizeof(char));
      strcpy(aux, car);
      for (int i=strlen(aux)+1;i;i--)
	*(aux+i) = *(aux+i-1);
      *aux=fsa[Sy].car;
      Search(Index, ClientServer, server, aux, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble-1, NbreApproxReplace, Replace, AlreadyModified+1, Result, ResultSize, ResultIndex, Weight + WeightAddDouble);
      free(aux);
    }
  }
  if (*car){
    if (NbreApproxErase && !AlreadyModified){
      if (!*(car+NbreApproxErase)){
	if (fsa[Index].info != (TYPEPTR)(~(0UL))){
	  if ((*Result)==NULL){
	    (*ResultSize)=LEXEDMAXRESULT;
	    if ((*Result = (TYPEPTR *)calloc(sizeof(TYPEPTR), LEXEDMAXRESULT))==NULL){
	      fputs("*** too much allocation\n", stderr);
	      exit(1);
	    }
	    (*ResultIndex)=0;
	  }
	  if ((*ResultIndex) == (*ResultSize)) {
	    (*ResultSize) *= 2;
	    if ((*Result = (TYPEPTR *)realloc(*Result, sizeof(TYPEPTR) * (*ResultSize)))==NULL){
	      fputs("*** too much allocation\n", stderr);
	      exit(1);
	    }
	  }
	  (*Result)[*ResultIndex]=fsa[Index].info;
	  (*Result)[(*ResultIndex)+1]=Weight + WeightErase;
	  (*Result)[(*ResultIndex)+2]=(TYPEPTR)~0UL;
	  (*ResultIndex)++;
	  (*ResultIndex)++;
	}
      }
      Search(Index, ClientServer, server, car+1, NbreApproxErase-1, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified?AlreadyModified-1:0, Result, ResultSize, ResultIndex, Weight + WeightErase);
    }
    if (NbreApproxEraseDouble && !AlreadyModified && *car==*(car+1)){
      if (!*(car+2)){
	if (fsa[Index].info != (TYPEPTR)(~(0UL))){
	  if ((*Result)==NULL){
	    (*ResultSize)=LEXEDMAXRESULT;
	    if ((*Result = (TYPEPTR *)calloc(sizeof(TYPEPTR), LEXEDMAXRESULT))==NULL){
	      fputs("*** too much allocation\n", stderr);
	      exit(1);
	    }
	    (*ResultIndex)=0;
	  }
	  if ((*ResultIndex) == (*ResultSize)) {
	    (*ResultSize) *= 2;
	    if ((*Result = (TYPEPTR *)realloc(*Result, sizeof(TYPEPTR) * (*ResultSize)))==NULL){
	      fputs("*** too much allocation\n", stderr);
	      exit(1);
	    }
	  }
	  (*Result)[*ResultIndex]=fsa[Index].info;
	  (*Result)[(*ResultIndex)+1]=Weight + WeightEraseDouble;
	  (*Result)[(*ResultIndex)+2]=(TYPEPTR)~0UL;
	  (*ResultIndex)++;
	  (*ResultIndex)++;
	}
      }
      Search(Index, ClientServer, server, car+1, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap, NbreApproxEraseDouble-1, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified?AlreadyModified-1:0, Result, ResultSize, ResultIndex, Weight + WeightEraseDouble);
    }
    if (NbreApproxSwap && *(car+1) && !AlreadyModified){
      char *aux;
      if ((aux=(char*)calloc(strlen(car)+2, sizeof(char)))==NULL){
	fputs("*** too much allocation\n", stderr);
	exit(1);
      }
      strcpy(aux, car);
      char c=*(car+1);
      *(car+1)=*(car);
      *(car)=c;
      Search(Index, ClientServer, server, car, NbreApproxErase, NbreApproxSubstitute, NbreApproxAdd, NbreApproxSwap-1, NbreApproxEraseDouble, NbreApproxAddDouble, NbreApproxReplace, Replace, AlreadyModified+2, Result, ResultSize, ResultIndex, Weight + WeightSwap);
      strcpy(car, aux);
      free(aux);
    }
  }
}

////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////
void List(TYPEPTR Index,
	  int ClientServer, 
	  TcpServer *server, 
	  char *Chaine,
	  int Rang,
	  FILE *Table)
{
  Chaine[Rang] = fsa[Index].car;
  if (fsa[Index].fils != (TYPEPTR)(~(0UL)))
    List(fsa[Index].fils, ClientServer, server, Chaine, Rang+1, Table);
  if (fsa[Index].frere != (TYPEPTR)(~(0UL)))
    List(fsa[Index].frere, ClientServer, server, Chaine, Rang, Table);
  if (fsa[Index].info != (TYPEPTR)(~(0UL))){
    Chaine[Rang] = fsa[Index].car;
    Chaine[Rang+1]=0;
    fputs (Chaine, stdout);
    putchar('\t');
    PrintResults(fsa[Index].info, 0, server, 0, Table);
    putchar('\n');
  }
}

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
SaveFSA(FILE *Fichier)
{
  TYPEPTR Taille;
  int NbrBytes;
  // encodage des offsets (16 ou 32 bits)
  NbrBytes=sizeof(TYPEPTR);
  fwrite(&NbrBytes, sizeof(NbrBytes), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "%d bytes\n", NbrBytes);
#endif //DIFF
  Taille=(TYPEPTR)~0UL;
  fwrite(&Taille, sizeof(Taille), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Test %lX\n", Taille);
#endif //DIFF
  Taille=LexedIndexation?(TYPEPTR)1:(TYPEPTR)0;
  fwrite(&Taille, sizeof(Taille), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Indexation %lX\n", Taille);
#endif //DIFF
  // nombre d'offsets du fsa
  nbreItem=0;
  Taille=0;
  LexiqueInit->SetIndexStaticFSA(Taille);
  fwrite(&Taille, sizeof(Taille), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Size FSA %lX\n", Taille);
#endif //DIFF
  if(Taille == (TYPEPTR)~0UL){
    fputs ("*** Error: Lexicon too large\n", stderr);
    fclose(Fichier);
    return 0;
  }
  Taille=0;
  LexiqueInit->SetIndexStaticInfo(Taille);
  fwrite(&Taille, sizeof(Taille), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Size Info %lX\n", Taille);
#endif //DIFF
  if(Taille == (TYPEPTR)~0UL){
    fputs("*** Error: Data too large\n", stderr);
    fclose(Fichier);
    return 0;
  }
#ifdef DIFF
  fprintf(stdout, "---FSA---\n");
#endif //DIFF
  LexiqueInit->PrintStaticFSA(Fichier);
#ifdef DIFF
  fprintf(stdout, "---Info---\n");
#endif //DIFF
  LexiqueInit->PrintStaticInfo(Fichier);
  fputs("*** Writing Data\n", stderr);
  fflush(Fichier);
  // table
  fflush(Fichier);
  fwrite(&LexedInitial, sizeof(LexedInitial), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Initial: %lX\n", LexedInitial);
#endif //DIFF
  return 1;
}

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
LoadFSA(FILE *Fichier){
  TYPEPTR TailleFsa;
  TYPEPTR TailleInfo;
  int NbrBytes;
  fputs("*** Loading Finite State Automata\n", stderr);
  fread(&NbrBytes, sizeof(NbrBytes), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "%d bytes\n", NbrBytes);
#endif //DIFF
  fread(&TailleFsa, sizeof(TailleFsa), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Test %lX\n", TailleFsa);
#endif //DIFF
  if(NbrBytes!=(sizeof(TYPEPTR)) || (TailleFsa!=(TYPEPTR)~0UL)){
    fputs("*** fatal error:\n*** lexicon not compiled with the good version of Lexed or on an incompatible system\n", stderr);
    fclose (Fichier);
    return 0;
  }
  fread(&TailleFsa, sizeof(TailleFsa), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Indexation: %lX\n", TailleFsa);
#endif //DIFF
  if (TailleFsa)
    LexedIndexation=1;
  fread(&TailleFsa, sizeof(TailleFsa), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Size FSA %lX\n", TailleFsa);
#endif //DIFF
  fread(&TailleInfo, sizeof(TailleInfo), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Size Info %lX\n", TailleInfo);
#endif //DIFF
#ifdef DIFF
  fprintf(stdout, "---FSA---\n");
#endif //DIFF
  fsa = new Fsa[TailleFsa+1];
  fread(fsa, sizeof(Fsa), TailleFsa, Fichier);
#ifdef DIFF
  for(unsigned long int TailleSy=0;TailleSy<TailleFsa;TailleSy++){
    fprintf(stdout, " so:%lX", fsa[TailleSy].fils);
    fprintf(stdout, " br:%lX", fsa[TailleSy].frere);
    fprintf(stdout, " in:%lX", fsa[TailleSy].info);
    fprintf(stdout, " <%c>\n", fsa[TailleSy].car);
  }
#endif //DIFF
#ifdef DIFF
  fprintf(stdout, "---Info---\n");
#endif //DIFF
  info = new InfoBuff [TailleInfo+1];
  fread(info, sizeof(InfoBuff), TailleInfo, Fichier);
#ifdef DIFF
  for(unsigned long int TailleSy=0;TailleSy<TailleInfo;TailleSy++){
    fprintf(stdout, " su:%lX of:%lX\n", info[TailleSy].suivant, info[TailleSy].offset);
  }
#endif //DIFF
  fread(&LexedInitial, sizeof(LexedInitial), 1, Fichier);
#ifdef DIFF
  fprintf(stdout, "Initial: %lX\n", LexedInitial);
#endif //DIFF
  return 1;
}

////////////////////////////////////////////////////////////
// Calcule les offsets du tableau FSA
////////////////////////////////////////////////////////////
void Arbre::SetIndexStaticFSA(TYPEPTR &Index)
{
  Arbre *LexiqueSy;
  for (LexiqueSy=this;LexiqueSy!=NULL;LexiqueSy=LexiqueSy->frere){
    LexiqueSy->adress = Index++;
    if (LexiqueSy->fils)
      LexiqueSy->fils->SetIndexStaticFSA(Index);
  }
}

////////////////////////////////////////////////////////////
// crit les enregistrements du FSA
// les offsets sont calculs sur 32 (vs 16) bits si long==1
////////////////////////////////////////////////////////////
void Arbre::PrintStaticFSA(FILE *Out)
{
  Fsa Elt;
  Arbre *LexiqueSy;
  if (this==LexiqueInit){
    LexedInitial=this->adress;
  }
  for (LexiqueSy=this;LexiqueSy;LexiqueSy=LexiqueSy->frere){
    Elt.fils=(LexiqueSy->fils==NULL)?(TYPEPTR)~0UL:LexiqueSy->fils->adress;
    Elt.frere=(LexiqueSy->frere==NULL)?(TYPEPTR)~0UL:LexiqueSy->frere->adress;
    Elt.info=(LexiqueSy->info==NULL)?(TYPEPTR)~0UL:LexiqueSy->info->adress;
    Elt.car=LexiqueSy->car;
    fwrite(&Elt, sizeof(Elt), 1, Out);
#ifdef DIFF
    fprintf(stdout, " so:%lX br:%lX in:%lX <%c>\n", Elt.fils, Elt.frere, Elt.info, Elt.car);
#endif //DIFF
    LexiqueSy->fils->PrintStaticFSA(Out);
  }
}

////////////////////////////////////////////////////////////
// Calcule les offsets du tableau info
////////////////////////////////////////////////////////////
void Arbre::SetIndexStaticInfo(TYPEPTR &Index)
{
  Info *InfoSy;
  Arbre *LexiqueSy;
  for (LexiqueSy=this;LexiqueSy!=NULL;LexiqueSy=LexiqueSy->frere)
    LexiqueSy->fils->SetIndexStaticInfo(Index);
  for (LexiqueSy=this;LexiqueSy!=NULL;LexiqueSy=LexiqueSy->frere){
    for (InfoSy=LexiqueSy->info;InfoSy!=NULL;InfoSy=InfoSy->GetSuivant()){
      InfoSy->adress = Index++;
    }
  }
}

////////////////////////////////////////////////////////////
// crit les enregistrement du tableau d'infos
// les offsets sont calculs sur 32 (vs 16) bits si long==1
////////////////////////////////////////////////////////////
void Arbre::PrintStaticInfo(FILE *Out){
  Info *InfoSy;
  Arbre *LexiqueSy;
  InfoBuff Elt;
  for (LexiqueSy=this;LexiqueSy!=NULL;LexiqueSy=LexiqueSy->frere)
    LexiqueSy->fils->PrintStaticInfo(Out);
  for (LexiqueSy=this;LexiqueSy!=NULL;LexiqueSy=LexiqueSy->frere){
    for (InfoSy=LexiqueSy->info;InfoSy!=NULL;InfoSy=InfoSy->GetSuivant()){
      Elt.suivant=(InfoSy->suivant!=NULL)?InfoSy->suivant->adress:(TYPEPTR)(~(0UL));
      Elt.offset=InfoSy->offset;
      fwrite(&Elt, sizeof(Elt), 1, Out);
#ifdef DIFF
      fprintf(stdout, " su:%lX of:%lX\n", Elt.suivant, Elt.offset);
#endif //DIFF
    }
  }
}

////////////////////////////////////////////////////////////
// ajoute un mot dans l'arbre  lettres
////////////////////////////////////////////////////////////
void Arbre::Add(char *Chaine,
		TYPEPTR Offset){
  Info *InfoSy;
  if (!this->car){
    this->car = Chaine[0];
    if (!Chaine[1]){
      if(this->info){
	this->info = new Info(this->info, Offset);
      }
      else
	this->info = new Info(NULL, Offset);
    }
    else{
      if (!this->fils)
	this->fils = new Arbre(NULL, NULL, NULL, Chaine[1]);
      this->fils->Add((char *)Chaine+1, Offset);
    }
  }
  else if (this->car == Chaine[0]){
    if (!Chaine[1]){
      if(this->info){
	this->info = new Info(this->info, Offset);
      }
      else
	this->info = new Info(NULL, Offset);
    }
    else{
      if (!this->fils)
	this->fils = new Arbre(NULL, NULL, NULL, Chaine[1]);
      this->fils->Add((char *)Chaine+1, Offset);
    }
  }
  else if (this->frere)
    this->frere->Add(Chaine, Offset);
  else{
    this->frere = new Arbre(NULL, NULL, NULL, Chaine[0]);
    this->frere->Add(Chaine, Offset);
  }
}
